# Main class for Powerpay21 API
class Powerpay21
	require 'digest'
	require 'net/http'

	# Constants - URLs
	URL_HASH = {
				:demo => {
							:init => "https://pay4.powercash21.com/powercash21-3-2/payment/init", 
					        :pre_auth => "https://pay4.powercash21.com/powercash21-3-2/backoffice/payment_preauthorize",
					        :auth => "https://pay4.powercash21.com/powercash21-3-2/backoffice/payment_authorize",
					        :refund => "https://pay4.powercash21.com/powercash21-3-2/backoffice/payment_refund",
					        :reveral => "https://pay4.powercash21.com/powercash21-3-2/backoffice/payment_reversal",
					        :capture => "https://pay4.powercash21.com/powercash21-3-2/backoffice/payment_capture"					

				},
				:live => {
					  		:init => "https://pay4.powercash21.com/powercash21-3-2/payment/init", 
					        :pre_auth => "https://pay4.powercash21.com/powercash21-3-2/backoffice/payment_preauthorize",
					        :auth => "https://pay4.powercash21.com/powercash21-3-2/backoffice/payment_authorize",
					        :refund => "https://pay4.powercash21.com/powercash21-3-2/backoffice/payment_refund",
					        :reveral => "https://pay4.powercash21.com/powercash21-3-2/backoffice/payment_reversal",
					        :capture => "https://pay4.powercash21.com/powercash21-3-2/backoffice/payment_capture"
				}
	}

	# Instance variables
	@merchantid = nil
	@secret=nil
	@live_demo=false

	def initialize(merchantid, secret, live=false)
		@merchantid=merchantid
		@secret=secret
		if live
			@live_demo=:live
		else
			@live_demo=:demo
		end
	end


	def self.help
		puts "This is a Powerpay21 API. Check our website for Guide"
	end

	def authorize(params)
		uri = URI(URL_HASH[@live_demo][:auth])

		signature = calculate_signature(params)

		params['signature'] = signature

		res = Net::HTTP.post_form(uri, params)
	end

	# Calculates the SHA1Sum signature for give param hash by 
	# sorting the keys in ascending order
	def calculate_signature(params)
		raw_string = ""
		params.sort.each do |key,value|
			raw_string += value
		end

		sha1 = Digest::SHA1.new

		sha1 << raw_string

		return sha1.hexdigest || ""

	end

	def pre_authorize
	end

	def capture
	end

	def refund
	end

	def cft
	end

	def cancel
	end

	def status
	end
end
